diff -pruN 1.3.1-1/debian/changelog 1.3.1-2/debian/changelog
--- 1.3.1-1/debian/changelog	2024-05-05 00:31:01.000000000 +0000
+++ 1.3.1-2/debian/changelog	2024-05-12 08:53:31.000000000 +0000
@@ -1,3 +1,11 @@
+hiredict (1.3.1-2) unstable; urgency=medium
+
+  * Source-only upload
+  * Run tests with autopkgtest instead of during build to break cyclical
+    dependencies (Closes: #1070915)
+
+ -- Maytham Alsudany <maytha8thedev@gmail.com>  Sun, 12 May 2024 16:53:31 +0800
+
 hiredict (1.3.1-1) unstable; urgency=medium
 
   * Initial release. (Closes: #1068948)
diff -pruN 1.3.1-1/debian/control 1.3.1-2/debian/control
--- 1.3.1-1/debian/control	2024-05-05 00:29:52.000000000 +0000
+++ 1.3.1-2/debian/control	2024-05-12 03:03:44.000000000 +0000
@@ -7,7 +7,6 @@ Build-Depends:
  debhelper-compat (= 13),
  libssl-dev,
  procps <!nocheck>,
- redict-server [linux-any kfreebsd-any] <!nocheck>,
 Standards-Version: 4.7.0
 Section: libs
 Homepage: https://codeberg.org/redict/hiredict
diff -pruN 1.3.1-1/debian/patches/0002-test-with-installed-lib.patch 1.3.1-2/debian/patches/0002-test-with-installed-lib.patch
--- 1.3.1-1/debian/patches/0002-test-with-installed-lib.patch	1970-01-01 00:00:00.000000000 +0000
+++ 1.3.1-2/debian/patches/0002-test-with-installed-lib.patch	2024-05-12 04:28:03.000000000 +0000
@@ -0,0 +1,36 @@
+From: Maytham Alsudany <maytha8thedev@gmail.com>
+Forwarded: not-needed
+Description: test with installed libs
+ Use the installed copy of hiredict instead of rebuilding, for autopkgtest use.
+
+--- a/Makefile
++++ b/Makefile
+@@ -164,7 +164,7 @@
+   DYLIB_PLUGIN=-Wl,-undefined -Wl,dynamic_lookup
+ endif
+ 
+-all: dynamic static hiredict-test pkgconfig
++all: dynamic static pkgconfig
+ 
+ dynamic: $(DYLIBNAME) $(SSL_DYLIB)
+ 
+@@ -181,7 +181,7 @@
+ read.o: read.c fmacros.h alloc.h read.h sds.h win32.h
+ sds.o: sds.c sds.h sdsalloc.h alloc.h
+ sockcompat.o: sockcompat.c sockcompat.h
+-test.o: test.c fmacros.h hiredict.h read.h sds.h alloc.h net.h sockcompat.h win32.h
++test.o: test.c
+ 
+ $(DYLIBNAME): $(OBJ)
+ 	$(DYLIB_MAKE_CMD) -o $(DYLIBNAME) $(OBJ) $(REAL_LDFLAGS)
+@@ -276,8 +276,8 @@
+     TEST_LDFLAGS += -levent
+ endif
+ 
+-hiredict-test: test.o $(TEST_LIBS)
+-	$(CC) -o $@ $(REAL_CFLAGS) -I. $^ $(REAL_LDFLAGS) $(TEST_LDFLAGS)
++hiredict-test: test.o
++	$(CC) -o $@ $(REAL_CFLAGS) $(shell pkgconf --cflags hiredict hiredict_ssl) -I. $^ $(REAL_LDFLAGS) $(shell pkgconf --libs hiredict hiredict_ssl) $(TEST_LDFLAGS)
+ 
+ hiredict-%: %.o $(STLIBNAME)
+ 	$(CC) $(REAL_CFLAGS) -o $@ $< $(TEST_LIBS) $(REAL_LDFLAGS)
diff -pruN 1.3.1-1/debian/patches/series 1.3.1-2/debian/patches/series
--- 1.3.1-1/debian/patches/series	2024-04-14 10:29:33.000000000 +0000
+++ 1.3.1-2/debian/patches/series	2024-05-12 04:14:24.000000000 +0000
@@ -1 +1,2 @@
 0001-cmake-config-support.patch
+0002-test-with-installed-lib.patch
diff -pruN 1.3.1-1/debian/rules 1.3.1-2/debian/rules
--- 1.3.1-1/debian/rules	2024-05-05 00:30:52.000000000 +0000
+++ 1.3.1-2/debian/rules	2024-05-12 07:00:54.000000000 +0000
@@ -1,7 +1,5 @@
 #!/usr/bin/make -f
 
-REDICT   = $(shell [ -e /usr/bin/redict-server ] && echo 1 || echo 0)
-
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 DPKG_EXPORT_BUILDFLAGS=1
 
@@ -23,6 +21,5 @@ execute_after_dh_fixperms:
 	chmod 644 debian/libhiredict-dev/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Hiredict/*.cmake
 
 override_dh_auto_test:
-ifeq ($(REDICT), 1)
-	-make check || [ "$(DEB_BUILD_ARCH_OS)" = "mipsel64" ]
-endif
+	# Tests are run with autopkgtest to break circular dependency loop on the
+	# redict package.
diff -pruN 1.3.1-1/debian/tests/control 1.3.1-2/debian/tests/control
--- 1.3.1-1/debian/tests/control	2024-04-13 19:47:32.000000000 +0000
+++ 1.3.1-2/debian/tests/control	2024-05-12 08:53:31.000000000 +0000
@@ -1,6 +1,7 @@
-Tests: trivial-build-test
+Tests: upstream-tests
 Depends:
+ @,
  gcc,
  libc-dev,
- pkg-config,
- @,
+ pkgconf,
+ redict-server,
diff -pruN 1.3.1-1/debian/tests/trivial-build-test 1.3.1-2/debian/tests/trivial-build-test
--- 1.3.1-1/debian/tests/trivial-build-test	2024-04-14 03:55:19.000000000 +0000
+++ 1.3.1-2/debian/tests/trivial-build-test	1970-01-01 00:00:00.000000000 +0000
@@ -1,34 +0,0 @@
-#!/bin/sh
-
-set -e
-
-BINARY="$AUTOPKGTEST_TMP/binary"
-SOURCE="$AUTOPKGTEST_TMP/binary.c"
-
-cat >"$SOURCE" <<-EOF
-#include <stdio.h>
-#include <unistd.h>
-#include <assert.h>
-#include <string.h>
-
-#include <hiredict/hiredict.h>
-
-int main (int argc, char **argv) {
-  char *s;
-  int len;
-  
-  len = redictFormatCommand(&s, "PING");
-  if (len < 0) {
-    return 1;
-  }
-  redictFreeCommand(s);
-  return 0;
-}
-EOF
-
-HIREDICT_CFLAGS="`pkgconf --cflags hiredict`"
-HIREDICT_LIBS="`pkgconf --libs hiredict`"
-gcc -o "$BINARY" $HIREDICT_CFLAGS -Wall -Werror "$SOURCE" $HIREDICT_LIBS
-chmod 755 "$BINARY"
-"$BINARY"
-
diff -pruN 1.3.1-1/debian/tests/upstream-tests 1.3.1-2/debian/tests/upstream-tests
--- 1.3.1-1/debian/tests/upstream-tests	1970-01-01 00:00:00.000000000 +0000
+++ 1.3.1-2/debian/tests/upstream-tests	2024-05-12 03:06:29.000000000 +0000
@@ -0,0 +1,5 @@
+#!/bin/sh
+
+set -eu
+
+make check
